<html>
<head>
<title>OGRE: OgreResourceGroupManager.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreResourceGroupManager.h</h1><a href="OgreResourceGroupManager_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef _ResourceGroupManager_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define _ResourceGroupManager_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreDataStream_8h.html">OgreDataStream.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreResource_8h.html">OgreResource.h</a>"</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include "<a class="code" href="OgreArchive_8h.html">OgreArchive.h</a>"</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include "<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>"</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>Ogre {
<a name="l00041"></a>00041 
<a name="l00068"></a><a class="code" href="classOgre_1_1ResourceGroupListener.html">00068</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ResourceGroupListener.html" title="This abstract class defines an interface which is called back during resource group...">ResourceGroupListener</a>
<a name="l00069"></a>00069     {
<a name="l00070"></a>00070     <span class="keyword">public</span>:
<a name="l00071"></a><a class="code" href="classOgre_1_1ResourceGroupListener.html#f53d0887dbc49e858f590a7ae4fb0a31">00071</a>         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1ResourceGroupListener.html" title="This abstract class defines an interface which is called back during resource group...">ResourceGroupListener</a>() {}
<a name="l00072"></a>00072 
<a name="l00082"></a>00082         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resourceGroupScriptingStarted(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName, <span class="keywordtype">size_t</span> scriptCount) = 0;
<a name="l00086"></a>00086         <span class="keyword">virtual</span> <span class="keywordtype">void</span> scriptParseStarted(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; scriptName) = 0;
<a name="l00089"></a>00089         <span class="keyword">virtual</span> <span class="keywordtype">void</span> scriptParseEnded(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; scriptName) = 0;
<a name="l00091"></a>00091         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resourceGroupScriptingEnded(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName) = 0;
<a name="l00092"></a>00092 
<a name="l00098"></a>00098         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resourceGroupLoadStarted(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName, <span class="keywordtype">size_t</span> resourceCount) = 0;
<a name="l00102"></a>00102         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resourceLoadStarted(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">ResourcePtr</a>&amp; resource) = 0;
<a name="l00105"></a>00105         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resourceLoadEnded(<span class="keywordtype">void</span>) = 0;
<a name="l00111"></a>00111         <span class="keyword">virtual</span> <span class="keywordtype">void</span> worldGeometryStageStarted(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; description) = 0;
<a name="l00117"></a>00117         <span class="keyword">virtual</span> <span class="keywordtype">void</span> worldGeometryStageEnded(<span class="keywordtype">void</span>) = 0;
<a name="l00118"></a>00118 
<a name="l00120"></a>00120         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resourceGroupLoadEnded(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName) = 0;
<a name="l00121"></a>00121 
<a name="l00122"></a>00122     };
<a name="l00171"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html">00171</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ResourceGroupManager.html" title="This singleton class manages the list of resource groups, and notifying the various...">ResourceGroupManager</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;ResourceGroupManager&gt;
<a name="l00172"></a>00172     {
<a name="l00173"></a>00173     <span class="keyword">public</span>:
<a name="l00174"></a>00174         <a class="code" href="OgrePrerequisites_8h.html#18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a> <span class="comment">// public to allow external locking</span>
<a name="l00176"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#62561ccf5ff323942a9a4fab94bee7e3">00176</a> <span class="comment"></span>        <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> DEFAULT_RESOURCE_GROUP_NAME;
<a name="l00178"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#41cf771aba39d52af949d5295e7e18e3">00178</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> INTERNAL_RESOURCE_GROUP_NAME;
<a name="l00180"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#6e898cd04cf46d851dd07c11d360ac4c">00180</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> BOOTSTRAP_RESOURCE_GROUP_NAME;
<a name="l00182"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#70da3137e703c147b98fbfbbebfbf023">00182</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> AUTODETECT_RESOURCE_GROUP_NAME;
<a name="l00184"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#2f859bb7ae7ea232379d238c8fdfd142">00184</a>         <span class="keyword">static</span> <span class="keywordtype">size_t</span> RESOURCE_SYSTEM_NUM_REFERENCE_COUNTS;
<a name="l00186"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceDeclaration.html">00186</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceDeclaration.html" title="Nested struct defining a resource declaration.">ResourceDeclaration</a>
<a name="l00187"></a>00187         {
<a name="l00188"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceDeclaration.html#e2e29633ab1798c3f99151618b963d73">00188</a>             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> resourceName;
<a name="l00189"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceDeclaration.html#ae401b65d364881e950953a3a15e2977">00189</a>             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> resourceType;
<a name="l00190"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceDeclaration.html#9322aeaf8777145d9fb4d71d30d133f3">00190</a>             <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader;
<a name="l00191"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceDeclaration.html#f4c80eff88505c4aa6a24fedb7411c56">00191</a>             <a class="code" href="namespaceOgre.html#0537f38d7a77fcbe9f600f6ed8a926d6" title="Name / value parameter pair (first = name, second = value).">NameValuePairList</a> parameters;
<a name="l00192"></a>00192         };
<a name="l00194"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#e26eacec6d13149f46c47d88c7110625">00194</a>         <span class="keyword">typedef</span> std::list&lt;ResourceDeclaration&gt; ResourceDeclarationList;
<a name="l00195"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#bb6fa5b78ff9f77f35b69cefd9d50283">00195</a>         <span class="keyword">typedef</span> std::map&lt;String, ResourceManager*&gt; ResourceManagerMap;
<a name="l00196"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#f875db11dc5aba6ab72ec40296af9a5c">00196</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">MapIterator&lt;ResourceManagerMap&gt;</a> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">ResourceManagerIterator</a>;
<a name="l00197"></a>00197     <span class="keyword">protected</span>:
<a name="l00199"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#82dcce5013ae2f212deed20212d29b59">00199</a>         ResourceManagerMap mResourceManagerMap;
<a name="l00200"></a>00200 
<a name="l00202"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#c86da086440c29cbcf2242be6a64833a">00202</a>         <span class="keyword">typedef</span> std::multimap&lt;Real, ScriptLoader*&gt; ScriptLoaderOrderMap;
<a name="l00203"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#72ebdd393f6b90d5850c4adad6a24b18">00203</a>         ScriptLoaderOrderMap mScriptLoaderOrderMap;
<a name="l00204"></a>00204 
<a name="l00205"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#def59af74fac7f67cd9dcdba3b6a0de4">00205</a>         <span class="keyword">typedef</span> std::vector&lt;ResourceGroupListener*&gt; ResourceGroupListenerList;
<a name="l00206"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#a661528e26f468563b5ecc15c173a48c">00206</a>         ResourceGroupListenerList mResourceGroupListenerList;
<a name="l00207"></a>00207 
<a name="l00209"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#25b7fbc15fa4cb442ca9c399e62e6048">00209</a>         <span class="keyword">typedef</span> std::map&lt;String, Archive*&gt; ResourceLocationIndex;
<a name="l00210"></a>00210 
<a name="l00212"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceLocation.html">00212</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceLocation.html" title="Resource location entry.">ResourceLocation</a>
<a name="l00213"></a>00213         {
<a name="l00215"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceLocation.html#6c67405ce5274cbf9e7ecefc1840539b">00215</a>             <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a>* archive;
<a name="l00217"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceLocation.html#89980295496fa459796c2561d0a40f3f">00217</a>             <span class="keywordtype">bool</span> recursive;
<a name="l00218"></a>00218         };
<a name="l00220"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#f3f395b7865646b87915df950a553d2d">00220</a>         <span class="keyword">typedef</span> std::list&lt;ResourceLocation*&gt; LocationList;
<a name="l00222"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#25cf2221b1cb13195aae84348f97055d">00222</a>         <span class="keyword">typedef</span> std::list&lt;ResourcePtr&gt; LoadUnloadResourceList;
<a name="l00224"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html">00224</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>
<a name="l00225"></a>00225         {
<a name="l00226"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#4b15ff98535d242c1bb7912b6007a3a9">00226</a>             <span class="keyword">enum</span> <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#4b15ff98535d242c1bb7912b6007a3a9">Status</a>
<a name="l00227"></a>00227             {
<a name="l00228"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#4b15ff98535d242c1bb7912b6007a3a9832fe1c1854534cc89460a355c1561e8">00228</a>                 UNINITIALSED = 0,
<a name="l00229"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#4b15ff98535d242c1bb7912b6007a3a95fd41aebef904c4603a411714061da11">00229</a>                 INITIALISING = 1,
<a name="l00230"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#4b15ff98535d242c1bb7912b6007a3a91a46cc3cb71014c4a85f4a07e1e41f7a">00230</a>                 INITIALISED = 2,
<a name="l00231"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#4b15ff98535d242c1bb7912b6007a3a9855699c308cdd8ccdb67358e4502c658">00231</a>                 LOADING = 3,
<a name="l00232"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#4b15ff98535d242c1bb7912b6007a3a98ec861cc686d84a5ad41433dd856464c">00232</a>                 LOADED = 4
<a name="l00233"></a>00233             };
<a name="l00235"></a>00235             <a class="code" href="OgrePrerequisites_8h.html#18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a>
<a name="l00237"></a>00237             <a class="code" href="OgrePrerequisites_8h.html#2fb96ea8ad9700f804480d1d7f5d692d">OGRE_MUTEX</a>(statusMutex)
<a name="l00239"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#9c7120b86ff8f19d81f0fac0a1523512">00239</a>             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> name;
<a name="l00241"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#2bdab6f4bfee7f0eeea58e6f9f70e30e">00241</a>             <span class="keywordtype">bool</span> initialised;
<a name="l00243"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#9f040193d573d26cf739005465f4acc7">00243</a>             LocationList locationList;
<a name="l00245"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#8e1f8b2b90535ba8e6a8d81a30888494">00245</a>             ResourceLocationIndex resourceIndexCaseSensitive;
<a name="l00247"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#40aa3f3b164cf9e1b3bf318dcf3c1283">00247</a>             ResourceLocationIndex resourceIndexCaseInsensitive;
<a name="l00249"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#130233f52a76fc38ca6fadc4d3182a9c">00249</a>             ResourceDeclarationList resourceDeclarations;
<a name="l00251"></a>00251             <span class="comment">// Group by loading order of the type (defined by ResourceManager)</span>
<a name="l00252"></a>00252             <span class="comment">// (e.g. skeletons and materials before meshes)</span>
<a name="l00253"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#ef0b67d6bc8ae99608568ea5967cd8d2">00253</a>             typedef std::map&lt;<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>, LoadUnloadResourceList*&gt; LoadResourceOrderMap;
<a name="l00254"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#c63251bf3f946d2b4dc42341b61d4d2a">00254</a>             LoadResourceOrderMap loadResourceOrderMap;
<a name="l00256"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#63a048530dfded3f7e6189743643578a">00256</a>             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> worldGeometry;
<a name="l00258"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#5c0395505e94f137cf4d5bced4054de6">00258</a>             <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* worldGeometrySceneManager;
<a name="l00259"></a>00259         };
<a name="l00261"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#c4c39ec5a2534bd4e1475b3a58094e78">00261</a>         typedef std::map&lt;<a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>*&gt; ResourceGroupMap;
<a name="l00262"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#b7f766cbec187cee71d7a5f2cbb5ce89">00262</a>         ResourceGroupMap mResourceGroupMap;
<a name="l00263"></a>00263 
<a name="l00265"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#dc2312c705ebf3f2cfacdea67b3a8357">00265</a>         String mWorldGroupName;
<a name="l00266"></a>00266 
<a name="l00272"></a>00272         <span class="keywordtype">void</span> parseResourceGroupScripts(<a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* grp);
<a name="l00277"></a>00277         <span class="keywordtype">void</span> createDeclaredResources(<a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* grp);
<a name="l00279"></a>00279         <span class="keywordtype">void</span> addCreatedResource(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">ResourcePtr</a>&amp; res, <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>&amp; group);
<a name="l00281"></a>00281         <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* getResourceGroup(const String&amp; name);
<a name="l00283"></a>00283         <span class="keywordtype">void</span> dropGroupContents(<a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* grp);
<a name="l00285"></a>00285         <span class="keywordtype">void</span> deleteGroup(<a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* grp);
<a name="l00287"></a>00287         <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* findGroupContainingResourceImpl(const String&amp; filename);
<a name="l00289"></a>00289         <span class="keywordtype">void</span> fireResourceGroupScriptingStarted(const String&amp; groupName, <span class="keywordtype">size_t</span> scriptCount);
<a name="l00291"></a>00291         <span class="keywordtype">void</span> fireScriptStarted(const String&amp; scriptName);
<a name="l00293"></a>00293         <span class="keywordtype">void</span> fireScriptEnded(const String&amp; scriptName);
<a name="l00295"></a>00295         <span class="keywordtype">void</span> fireResourceGroupScriptingEnded(const String&amp; groupName);
<a name="l00297"></a>00297         <span class="keywordtype">void</span> fireResourceGroupLoadStarted(const String&amp; groupName, <span class="keywordtype">size_t</span> resourceCount);
<a name="l00299"></a>00299         <span class="keywordtype">void</span> fireResourceStarted(const <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">ResourcePtr</a>&amp; resource);
<a name="l00301"></a>00301         <span class="keywordtype">void</span> fireResourceEnded(<span class="keywordtype">void</span>);
<a name="l00303"></a>00303         <span class="keywordtype">void</span> fireResourceGroupLoadEnded(const String&amp; groupName);
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 
<a name="l00308"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#b40aa8555ffed48c406fc9249cced867">00308</a>         <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* mCurrentGroup;
<a name="l00309"></a>00309     public:
<a name="l00310"></a>00310         <a class="code" href="classOgre_1_1ResourceGroupManager.html" title="This singleton class manages the list of resource groups, and notifying the various...">ResourceGroupManager</a>();
<a name="l00311"></a>00311         virtual ~ResourceGroupManager();
<a name="l00312"></a>00312 
<a name="l00348"></a>00348         <span class="keywordtype">void</span> createResourceGroup(const String&amp; name);
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00390"></a>00390         <span class="keywordtype">void</span> initialiseResourceGroup(const String&amp; name);
<a name="l00391"></a>00391 
<a name="l00395"></a>00395         <span class="keywordtype">void</span> initialiseAllResourceGroups(<span class="keywordtype">void</span>);
<a name="l00396"></a>00396 
<a name="l00414"></a>00414         <span class="keywordtype">void</span> loadResourceGroup(const String&amp; name, <span class="keywordtype">bool</span> loadMainResources = true, 
<a name="l00415"></a>00415             <span class="keywordtype">bool</span> loadWorldGeom = true);
<a name="l00416"></a>00416 
<a name="l00432"></a>00432         <span class="keywordtype">void</span> unloadResourceGroup(const String&amp; name, <span class="keywordtype">bool</span> reloadableOnly = true);
<a name="l00433"></a>00433 
<a name="l00445"></a>00445         <span class="keywordtype">void</span> unloadUnreferencedResourcesInGroup(const String&amp; name, 
<a name="l00446"></a>00446             <span class="keywordtype">bool</span> reloadableOnly = true);
<a name="l00447"></a>00447 
<a name="l00457"></a>00457         <span class="keywordtype">void</span> clearResourceGroup(const String&amp; name);
<a name="l00458"></a>00458         
<a name="l00464"></a>00464         <span class="keywordtype">void</span> destroyResourceGroup(const String&amp; name);
<a name="l00465"></a>00465 
<a name="l00487"></a>00487         <span class="keywordtype">void</span> addResourceLocation(const String&amp; name, const String&amp; locType, 
<a name="l00488"></a>00488             const String&amp; resGroup = DEFAULT_RESOURCE_GROUP_NAME, <span class="keywordtype">bool</span> recursive = false);
<a name="l00490"></a>00490         <span class="keywordtype">void</span> removeResourceLocation(const String&amp; name, 
<a name="l00491"></a>00491             const String&amp; resGroup = DEFAULT_RESOURCE_GROUP_NAME);
<a name="l00492"></a>00492 
<a name="l00527"></a>00527         <span class="keywordtype">void</span> declareResource(const String&amp; name, const String&amp; resourceType,
<a name="l00528"></a>00528             const String&amp; groupName = DEFAULT_RESOURCE_GROUP_NAME,
<a name="l00529"></a>00529             const <a class="code" href="namespaceOgre.html#0537f38d7a77fcbe9f600f6ed8a926d6" title="Name / value parameter pair (first = name, second = value).">NameValuePairList</a>&amp; loadParameters = <a class="code" href="namespaceOgre.html#0537f38d7a77fcbe9f600f6ed8a926d6" title="Name / value parameter pair (first = name, second = value).">NameValuePairList</a>());
<a name="l00569"></a>00569         <span class="keywordtype">void</span> declareResource(const String&amp; name, const String&amp; resourceType,
<a name="l00570"></a>00570             const String&amp; groupName, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader,
<a name="l00571"></a>00571             const NameValuePairList&amp; loadParameters = NameValuePairList());
<a name="l00582"></a>00582         <span class="keywordtype">void</span> undeclareResource(const String&amp; name, const String&amp; groupName);
<a name="l00583"></a>00583 
<a name="l00603"></a>00603         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a> openResource(const String&amp; resourceName, 
<a name="l00604"></a>00604             const String&amp; groupName = DEFAULT_RESOURCE_GROUP_NAME,
<a name="l00605"></a>00605             <span class="keywordtype">bool</span> searchGroupsIfNotFound = true, <a class="code" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a>* resourceBeingLoaded = 0);
<a name="l00606"></a>00606 
<a name="l00618"></a>00618         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamListPtr</a> openResources(const String&amp; pattern, 
<a name="l00619"></a>00619             const String&amp; groupName = DEFAULT_RESOURCE_GROUP_NAME);
<a name="l00620"></a>00620         
<a name="l00629"></a>00629         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">StringVectorPtr</a> listResourceNames(const String&amp; groupName, <span class="keywordtype">bool</span> dirs = false);
<a name="l00630"></a>00630 
<a name="l00637"></a>00637         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">FileInfoListPtr</a> listResourceFileInfo(const String&amp; groupName, <span class="keywordtype">bool</span> dirs = false);
<a name="l00638"></a>00638 
<a name="l00650"></a>00650         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">StringVectorPtr</a> findResourceNames(const String&amp; groupName, const String&amp; pattern,
<a name="l00651"></a>00651             <span class="keywordtype">bool</span> dirs = false);
<a name="l00652"></a>00652 
<a name="l00657"></a>00657         <span class="keywordtype">bool</span> resourceExists(const String&amp; group, const String&amp; filename);
<a name="l00658"></a>00658 
<a name="l00663"></a>00663         <span class="keywordtype">bool</span> resourceExists(<a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* group, const String&amp; filename);
<a name="l00670"></a>00670         const String&amp; findGroupContainingResource(const String&amp; filename);
<a name="l00671"></a>00671 
<a name="l00681"></a>00681         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">FileInfoListPtr</a> findResourceFileInfo(const String&amp; group, const String&amp; pattern,
<a name="l00682"></a>00682             <span class="keywordtype">bool</span> dirs = false);
<a name="l00683"></a>00683 
<a name="l00684"></a>00684         
<a name="l00688"></a>00688         <span class="keywordtype">void</span> addResourceGroupListener(<a class="code" href="classOgre_1_1ResourceGroupListener.html" title="This abstract class defines an interface which is called back during resource group...">ResourceGroupListener</a>* l);
<a name="l00690"></a>00690         <span class="keywordtype">void</span> removeResourceGroupListener(<a class="code" href="classOgre_1_1ResourceGroupListener.html" title="This abstract class defines an interface which is called back during resource group...">ResourceGroupListener</a>* l);
<a name="l00691"></a>00691 
<a name="l00698"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#407415b99c1df3b275e2609e16e8b39f">00698</a>         <span class="keywordtype">void</span> setWorldResourceGroupName(const String&amp; groupName) {mWorldGroupName = groupName;}
<a name="l00699"></a>00699 
<a name="l00701"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#6a5134c3cf869331c5740a6a5e2728f0">00701</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getWorldResourceGroupName(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mWorldGroupName; }
<a name="l00702"></a>00702 
<a name="l00716"></a>00716         <span class="keywordtype">void</span> linkWorldGeometryToResourceGroup(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, 
<a name="l00717"></a>00717             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; worldGeometry, <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* sceneManager);
<a name="l00718"></a>00718 
<a name="l00723"></a>00723         <span class="keywordtype">void</span> unlinkWorldGeometryFromResourceGroup(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group);
<a name="l00724"></a>00724 
<a name="l00726"></a>00726         <span class="keywordtype">void</span> shutdownAll(<span class="keywordtype">void</span>);
<a name="l00727"></a>00727 
<a name="l00728"></a>00728 
<a name="l00738"></a>00738         <span class="keywordtype">void</span> _registerResourceManager(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; resourceType, <a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* rm);
<a name="l00739"></a>00739 
<a name="l00746"></a>00746         <span class="keywordtype">void</span> _unregisterResourceManager(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; resourceType);
<a name="l00747"></a>00747 
<a name="l00750"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#7e64ea1228280465675f0b1438d21e4a">00750</a>         <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">ResourceManagerIterator</a> getResourceManagerIterator()
<a name="l00751"></a>00751         { <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">ResourceManagerIterator</a>(
<a name="l00752"></a>00752             mResourceManagerMap.begin(), mResourceManagerMap.end()); }
<a name="l00753"></a>00753 
<a name="l00758"></a>00758         <span class="keywordtype">void</span> _registerScriptLoader(<a class="code" href="classOgre_1_1ScriptLoader.html" title="Abstract class defining the interface used by classes which wish to perform script...">ScriptLoader</a>* su);
<a name="l00759"></a>00759 
<a name="l00763"></a>00763         <span class="keywordtype">void</span> _unregisterScriptLoader(<a class="code" href="classOgre_1_1ScriptLoader.html" title="Abstract class defining the interface used by classes which wish to perform script...">ScriptLoader</a>* su);
<a name="l00764"></a>00764 
<a name="l00768"></a>00768         <a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* _getResourceManager(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; resourceType);
<a name="l00769"></a>00769 
<a name="l00773"></a>00773         <span class="keywordtype">void</span> _notifyResourceCreated(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">ResourcePtr</a>&amp; res);
<a name="l00774"></a>00774 
<a name="l00778"></a>00778         <span class="keywordtype">void</span> _notifyResourceRemoved(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">ResourcePtr</a>&amp; res);
<a name="l00779"></a>00779 
<a name="l00782"></a>00782         <span class="keywordtype">void</span> _notifyResourceGroupChanged(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; oldGroup, <a class="code" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a>* res);
<a name="l00783"></a>00783 
<a name="l00788"></a>00788         <span class="keywordtype">void</span> _notifyAllResourcesRemoved(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* manager);
<a name="l00789"></a>00789 
<a name="l00797"></a>00797         <span class="keywordtype">void</span> _notifyWorldGeometryStageStarted(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; description);
<a name="l00805"></a>00805         <span class="keywordtype">void</span> _notifyWorldGeometryStageEnded(<span class="keywordtype">void</span>);
<a name="l00806"></a>00806 
<a name="l00812"></a>00812         <a class="code" href="namespaceOgre.html#783e5227595f351519627abfb740ec85">StringVector</a> getResourceGroups(<span class="keywordtype">void</span>);
<a name="l00819"></a>00819         ResourceDeclarationList getResourceDeclarationList(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName);
<a name="l00820"></a>00820 
<a name="l00821"></a>00821 
<a name="l00837"></a>00837         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ResourceGroupManager.html" title="This singleton class manages the list of resource groups, and notifying the various...">ResourceGroupManager</a>&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00853"></a>00853         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ResourceGroupManager.html" title="This singleton class manages the list of resource groups, and notifying the various...">ResourceGroupManager</a>* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00854"></a>00854 
<a name="l00855"></a>00855     };
<a name="l00856"></a>00856 }
<a name="l00857"></a>00857 
<a name="l00858"></a>00858 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:55 2008
</p>
</body>
</html>
